#include <stdio.h>
#include "../diksamc.h"


char *st_diksam_lang_dkh_text[] = {
    "void print(string str);",
    "native_pointer fopen(string file_name, string mode);",
    "string fgets(native_pointer fp);",
    "void fputs(string str, native_pointer fp);",
    "void fclose(native_pointer fp);",
    "",
    "void println(string str) {",
    "    print(str + \"\\n\");",
    "}",
    "",
    "double to_double(int int_value) {",
    "    return int_value;",
    "}",
    "",
    "int to_int(double double_value) {",
    "    return double_value;",
    "}",
    "",
    "class StackTrace {",
    "    int\tline_number;",
    "    string file_name;",
    "    string function_name;",
    "}",
    "",
    "abstract class Exception {",
    "    public string message;",
    "    public StackTrace[] stack_trace;",
    "    public void print_stack_trace() {",
    "\tint i;",
    "\tprintln(\"Exception occured. \" + this.message);",
    "\tfor (i = 0; i < this.stack_trace.size(); i++) {",
    "\t    println(\"\\tat \" ",
    "\t\t    + this.stack_trace[i].function_name",
    "\t\t    + \"(\" + this.stack_trace[i].file_name",
    "\t\t    + \":\" + this.stack_trace[i].line_number + \")\");",
    "\t}",
    "    }",
    "    public virtual constructor initialize() {",
    "\tthis.stack_trace = new StackTrace[0];",
    "    }",
    "}",
    "",
    "abstract class BugException : Exception {",
    "}",
    "",
    "abstract class RuntimeException : Exception {",
    "}",
    "",
    "class NullPointerException : BugException {",
    "}",
    "",
    "class ArrayIndexOutOfBoundsException : BugException {",
    "}",
    "",
    "class StringIndexOutOfBoundsException : BugException {",
    "}",
    "",
    "class DivisionByZeroException : RuntimeException {",
    "}",
    "",
    "class MultibyteCharacterConvertionException : RuntimeException {",
    "}",
    "",
    "class ClassCastException : BugException {",
    "}",
    NULL
};
char *st_diksam_lang_dkm_text[] = {
    "require diksam.lang;",
    "",
    NULL
};

BuiltinScript dkc_builtin_script[] = {
    {"diksam.lang", DKH_SOURCE, st_diksam_lang_dkh_text},
    {"diksam.lang", DKM_SOURCE, st_diksam_lang_dkm_text},
    {NULL, DKM_SOURCE, NULL}
};
